package students.unt.project;

import java.io.IOException;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import Entities.CarEntity;
import Entities.FlightEntity;
import Entities.HotelEntity;
import beans.addItrBean;
import beans.addUserBean;
import beans.loginData;

import com.google.gson.Gson;
//HttpSession session session.getAttribute("user)
/**
 * Handles requests for the application home page.
 */
@Controller
public class HomeController {
	private int userId = 0;
	QueriesService query = new QueriesService();
	private static final Logger logger = LoggerFactory.getLogger(HomeController.class);
	
	/**
	 * Simply selects the home view to render by returning its name.
	 * @throws IOException 
	 */
	@RequestMapping(value="/login/validate", method = RequestMethod.POST)
	public ModelAndView validate(@RequestBody String data,HttpServletResponse response,HttpServletRequest request){
		Gson g = new Gson();
		loginData login = g.fromJson(data, loginData.class);
		try{
		userId = query.validatelogin(login.getUsername(), login.getPassword());
		}
		catch(Exception e){
			return null;
		}
		
		if(userId == 0){
			return null;
		}
		else{
		ModelAndView mv = new ModelAndView();
		mv.setViewName("redirect:/front");	
		return mv;
		}
	}
	@RequestMapping(value = "/login/username", method = RequestMethod.POST)
	@ResponseBody
	public String username(@RequestBody String username){
		List<String> s = null;
		s = query.username(username);
		if(s.isEmpty()){
			return "true";
		}
		else{
			return "false";
		}	
	}
	@RequestMapping(value = "/login/adduser", method = RequestMethod.POST)
	public  ModelAndView  adduser(@RequestBody String data){
		Gson g = new Gson();
		addUserBean y = g.fromJson(data, addUserBean.class);
		query.adduser(y);
		int x = query.validatelogin(y.getInUsername(), y.getInpassword());
		if(x==0){
			return null;
		}
		else{
			userId = x;
			ModelAndView mv = new ModelAndView();
			mv.setViewName("redirect:/front");	
			return mv;
		}	
	}
	@RequestMapping(value = "/addItr", method = RequestMethod.POST)
	public  ModelAndView  addItr(@RequestBody String data){
		Gson g = new Gson();
		addItrBean y = g.fromJson(data, addItrBean.class);
		query.addItr(y, userId);
			ModelAndView mv = new ModelAndView();
			mv.setViewName("redirect:/front");	
			return mv;
	}
	@RequestMapping(value = "/logout", method = RequestMethod.POST)
	public  ModelAndView  logout(){
			ModelAndView mv = new ModelAndView();
			mv.setViewName("redirect:/login");	
			return mv;
	}
	@RequestMapping(value = "/deleteItr", method = RequestMethod.POST)
	@ResponseBody
	public  String  deleItr(@RequestBody String data){
		Gson g = new Gson();
		int TripID = g.fromJson(data, int.class);
		query.deleteItr(TripID);
		return "true";
		
	}
	@RequestMapping(value = "/login", method = RequestMethod.GET)
	public String login(){
	return "login";	
	}
	@RequestMapping(value = "/front", method = RequestMethod.GET)
	public String front(){
		if(userId != 0){
	return "front";	
		}
		else{
			return "login";
		}
	}
	@RequestMapping(value = "/getID", method = RequestMethod.GET)
	public @ResponseBody String getID() {
		Gson g = new Gson();
		return g.toJson(userId);
	}
	@RequestMapping(value = "/getInfo", method = RequestMethod.GET)
	public @ResponseBody String getInfo() {
		Gson g = new Gson();
		return g.toJson(query.getInfo(userId));
	}
	@RequestMapping(value = "/getflights", method = RequestMethod.GET)
	public @ResponseBody String getflights() {
		Gson g = new Gson();
		List<FlightEntity> flights = query.flights();
		return g.toJson(flights);
	}
	@RequestMapping(value = "/gethotels", method = RequestMethod.GET)
	public @ResponseBody String gethotels() {
		Gson g = new Gson();
		List<HotelEntity> hotels = query.hotels();
		return g.toJson(hotels);
	}
	@RequestMapping(value = "/getcars", method = RequestMethod.GET)
	public @ResponseBody String getcars() {
		Gson g = new Gson();
		List<CarEntity> cars = query.cars();
		return g.toJson(cars);
	}
	@RequestMapping(value = "/getRP", method = RequestMethod.GET)
	public @ResponseBody String GetRP(){
	return Integer.toString(query.getRp(userId));	
	}
	@RequestMapping(value = "/getRewards", method = RequestMethod.GET)
	public @ResponseBody String GetRewards(){
		Gson g = new Gson();
	return g.toJson(query.getRewards());	
	}
	@RequestMapping(value = "/getRooms", method = RequestMethod.GET)
	public @ResponseBody String GetRooms(){
		Gson g = new Gson();
	return g.toJson(query.getRooms());	
	}
	@RequestMapping(value = "/getItr", method = RequestMethod.GET)
	public @ResponseBody String GetItr(){
		Gson g = new Gson();
		String stuff = g.toJson(query.getItr(userId));
	return "{identifier:'pDate',items:"+stuff+"}";
	}
	@RequestMapping(value = "/getRCC", method = RequestMethod.GET)
	public @ResponseBody String GetRCC(){
		Gson g = new Gson();
	return g.toJson(query.getRCC());	
	}	
	}
	
