package students.unt.project;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.springframework.jdbc.core.RowMapper;

import Entities.CarEntity;
import Entities.CustomerEntity;
import Entities.FlightEntity;
import Entities.HotelEntity;
import Entities.ItineraryEntity;
import Entities.PaymentEntity;
import Entities.RentalCompanyEntity;
import Entities.RoomEntity;
import Entities.SaleEntity;
import Entities.location;

class hotelMapper implements RowMapper{
	public Object mapRow(ResultSet rs, int rowNum) throws SQLException{
		HotelEntity temp = new HotelEntity();
		location l = new location();
		l.setAddress(rs.getString("Address"));
		l.setCity(rs.getString("City"));
		l.setState(rs.getString("State"));
		l.setZip(rs.getInt("Zip"));
		temp.setDiscription(rs.getString("Description"));
		temp.setName(rs.getString("Name"));
		temp.setRating(rs.getInt("Rating"));
		temp.setLocation(l);
		temp.setID(rs.getInt("HotelID"));
		return temp;
	}
	
}
class flightMapper implements RowMapper{
	public Object mapRow(ResultSet rs, int rowNum) throws SQLException{
		FlightEntity temp = new FlightEntity();
		temp.setAirline(rs.getString("Airline"));
		temp.setDep(rs.getString("DepCity"));
		temp.setDepTime(rs.getString("DepTime"));
		temp.setArrival(rs.getString("ArCity"));
		temp.setArrivalTime(rs.getString("ArTime"));
		temp.setDate(rs.getString("Date"));
		temp.setFlightNum(rs.getInt("FlightNumber"));
		temp.setPrice(rs.getInt("Price"));
		temp.setAirport(rs.getString("AirportName"));
		temp.setAirportID(rs.getInt("AirportID"));
		temp.setID(rs.getInt("airport"));
		return temp;
	}
	
}
class carMapper implements RowMapper{
	public Object mapRow(ResultSet rs, int rowNum) throws SQLException{
		CarEntity temp = new CarEntity();
		temp.setMake(rs.getString("Make"));
		temp.setModel(rs.getString("Model"));
		temp.setType(rs.getString("Type"));
		temp.setColor(rs.getString("Color"));
		temp.setYear(rs.getInt("Year"));
		temp.setID(rs.getInt("CarID"));
		temp.setRate(rs.getInt("Rate"));
		temp.setRccID(rs.getInt("RCC"));
		return temp;
	}
}
	class username implements RowMapper{
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException{
			String temp =rs.getString("username");
			return temp;
		}
}
	class infoMapper implements RowMapper{
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException{
			CustomerEntity temp = new CustomerEntity();
			location l = new location();
			l.setAddress(rs.getString("Address"));
			l.setCity(rs.getString("City"));
			l.setState(rs.getString("State"));
			l.setZip(rs.getInt("Zip"));
			temp.setLocation(l);
			temp.setEmail(rs.getString("Email"));
			temp.setName(rs.getString("Name"));
			temp.setUsername(rs.getString("Username"));
			return temp;
		}
	}
	class saleMapper implements RowMapper{
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException{
			SaleEntity temp = new SaleEntity();
			temp.setID(rs.getInt("SaleID"));
			temp.setDes(rs.getString("Description"));
			temp.setAmount(rs.getInt("Amount"));
			temp.setPoints(rs.getInt("Points"));
			return temp;
		}
	}
	class roomMapper implements RowMapper{
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException{
			RoomEntity temp = new RoomEntity();
			temp.setID(rs.getInt("RoomID"));
			temp.setSize(rs.getString("Size"));
			temp.setRate(rs.getInt("Rate"));
			temp.setHotelID(rs.getInt("Hotel"));
			return temp;
		}
	}
	class ItrMapper implements RowMapper{
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException{
			RoomEntity room = new RoomEntity();
			CarEntity car = new CarEntity();
			FlightEntity flight = new FlightEntity();
			HotelEntity hotel = new HotelEntity();
			RentalCompanyEntity rcc =new RentalCompanyEntity();
			PaymentEntity pay = new PaymentEntity();
			ItineraryEntity itr = new ItineraryEntity();
			location fl = new location();
			location cl = new location();
			location hl = new location();
			fl.setAddress(rs.getString("fAddress"));
			fl.setCity(rs.getString("fCity"));
			fl.setState(rs.getString("fState"));
			fl.setZip(rs.getInt("fZip"));
			flight.setAirline(rs.getString("Airline"));
			flight.setAirport(rs.getString("AirportName"));
			flight.setArrival(rs.getString("ArCity"));
			flight.setDep(rs.getString("DepCity"));
			flight.setArrivalTime(rs.getString("ArTime"));
			flight.setDepTime(rs.getString("DepTime"));
			flight.setDate(rs.getString("Date"));
			flight.setPrice(rs.getInt("Price"));
			flight.setLoc(fl);
			cl.setAddress(rs.getString("cAddress"));
			cl.setCity(rs.getString("cCity"));
			cl.setState(rs.getString("cState"));
			cl.setZip(rs.getInt("cZip"));
			rcc.setName(rs.getString("cName"));
			rcc.setCompanyLocation(cl);
			car.setRcc(rcc);
			car.setColor(rs.getString("Color"));
			car.setMake(rs.getString("Make"));
			car.setModel(rs.getString("Model"));
			car.setRate(rs.getInt("rate"));
			car.setType(rs.getString("Type"));
			car.setYear(rs.getInt("Year"));
			hl.setAddress(rs.getString("hAddress"));
			hl.setCity(rs.getString("hCity"));
			hl.setState(rs.getString("hState"));
			hl.setZip(rs.getInt("hZip"));
			hotel.setLoc(hl);
			hotel.setName(rs.getString("Name"));
			hotel.setRating(rs.getInt("Rating"));
			room.setRate(rs.getInt("rRate"));
			room.setSize(rs.getString("Size"));
			room.setRoomNumber(rs.getInt("Number"));
			hotel.setRoom(room);
			pay.setCardNum(rs.getString("CardNumber"));
			pay.setVendor(rs.getString("Vendor"));
			pay.setDate(rs.getString("pDate"));
			itr.setFlight(flight);
			itr.setCar(car);
			itr.setHotel(hotel);
			itr.setPay(pay);
			itr.setpDate(rs.getString("pDate"));
			itr.setID(rs.getInt("TripID"));
			return itr;
		}
	}
	class rccMapper implements RowMapper{
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException{
			RentalCompanyEntity rcc =new RentalCompanyEntity();
			rcc.setDescription(rs.getString("Discription"));
			rcc.setID(rs.getInt("rccID"));
			rcc.setName(rs.getString("Name"));
			rcc.setCity(rs.getString("City"));
			rcc.setState(rs.getString("State"));
			return rcc;
		}
	}
