package students.unt.project;

import java.util.List;

import org.springframework.jdbc.core.JdbcTemplate;

import Entities.CarEntity;
import Entities.CustomerEntity;
import Entities.FlightEntity;
import Entities.HotelEntity;
import Entities.ItineraryEntity;
import Entities.RentalCompanyEntity;
import Entities.SaleEntity;
import beans.addItrBean;
import beans.addUserBean;

public class QueriesService {
	JdbcTemplate j = new JdbcTemplate();

	public QueriesService() {
		setSource();
	}

	@SuppressWarnings("unchecked")
	public int validatelogin(String username, String password) {
		int i = 0;
		i = j.queryForInt("SELECT CustomerID FROM customer where username='"
				+ username + "' and password='" + password + "'");
		return i;
	}

	@SuppressWarnings("unchecked")
	public List<HotelEntity> hotels() {
		List<HotelEntity> is;
		is = j.query(
				"SELECT * FROM `hotel` , `hotellocation` WHERE hotel.Location = hotellocation.LocationID AND (SELECT Count(Available) FROM room WHERE hotel.HotelID = room.Hotel AND Available=1)>0",
				new hotelMapper());
		return is;
	}

	@SuppressWarnings("unchecked")
	public List<FlightEntity> flights() {
		List<FlightEntity> is;
		is = j.query("SELECT * FROM flight,airport WHERE flight.airport = airport.AirportID", new flightMapper());
		return is;
	}

	@SuppressWarnings("unchecked")
	public List<CarEntity> cars() {
		List<CarEntity> is;
		is = j.query("SELECT * FROM car WHERE Available =1", new carMapper());
		return is;
	}

	@SuppressWarnings("unchecked")
	public List<String> username(String username) {
		List<String> is = null;
		is = j.query("SELECT username FROM customer where username='"
				+ username + "'", new username());
		return is;
	}

	@SuppressWarnings("unchecked")
	public void adduser(addUserBean y) {
		j.execute("START TRANSACTION;");
		j.execute("INSERT INTO customerlocation (Address,City,State,Zip) VALUES ('" + y.getAddress()
				+ "', '" + y.getCity() + "', '" + y.getState() + "', "
				+ y.getZip() + ");");
		j.execute("INSERT INTO customer (Name,Location,Email,Password,Username,Points) VALUES ('" + y.getFname() + "_"+ y.getLname()+ "', (SELECT LocationID FROM customerlocation WHERE Address='"+ y.getAddress() + "'AND City ='" + y.getCity()
				+ "'AND State ='" + y.getState() + "'AND Zip = '" + y.getZip()+ "'),'" + y.getEmail() + "', '" + y.getInpassword() + "', '"+ y.getInUsername() + "',0);");
		j.execute("COMMIT;");
	}

	@SuppressWarnings("unchecked")
	public int getRp(int userID) {
		return j.queryForInt("SELECT Points FROM `customer` WHERE CustomerID='"
				+ userID + "'");
	}

	@SuppressWarnings("unchecked")
	public List<CustomerEntity> getInfo(int userID) {
		String arg = "SELECT * FROM `customer` , `customerlocation` WHERE customer.Location = customerlocation.LocationID and CustomerID="
				+ userID;
		return j.query(arg, new infoMapper());
	}

	@SuppressWarnings("unchecked")
	public List<SaleEntity> getRewards() {
		String arg = "SELECT * FROM `sale`";
		List<SaleEntity> p;
		p = j.query(arg, new saleMapper());
		return p;
	}

	@SuppressWarnings("unchecked")
	public List<SaleEntity> getRooms() {
		String arg = "SELECT * FROM `room`";
		List<SaleEntity> p;
		p = j.query(arg, new roomMapper());
		return p;
	}

	@SuppressWarnings("unchecked")
	public List<ItineraryEntity> getItr(int user) {
		String arg = "SELECT * FROM `itr` WHERE customer=" + user;
		List<ItineraryEntity> p;
		p = j.query(arg, new ItrMapper());

		return p;
	}

	@SuppressWarnings("unchecked")
	public List<RentalCompanyEntity> getRCC() {
		String arg = "SELECT * FROM `rcc`,`rcclocation` WHERE rcc.Location = rcclocation.LocationID AND (SELECT Count(Available) FROM car WHERE car.rcc = rcc.rccID AND Available=1)>0";
		List<RentalCompanyEntity> p;
		p = j.query(arg, new rccMapper());
		return p;
	}

	@SuppressWarnings("unchecked")
	public void addItr(addItrBean i,int user) {
		System.out.println(i.getStamp());
		j.execute("START TRANSACTION;");
		j.execute("INSERT INTO payment VALUES (0, '"+i.getVendor()+"', '"+i.getCn()+"', "+i.getTot()+", '"+i.getStamp()+"');");
		j.execute("INSERT INTO itinerary VALUES (0, "+user+","+i.getFlight()+","+i.getRoom()+","+i.getCar()+", (SELECT PaymentID FROM payment WHERE Vendor = '"+i.getVendor()+"' AND CardNumber = "+i.getCn()+" AND Date='"+i.getStamp()+"'));");
		j.execute("UPDATE Room SET Available = 0 WHERE RoomID = "+i.getRoom()+";");
		j.execute("UPDATE flight SET Capacity = Capacity - 1 WHERE FlightNumber = "+i.getFlight()+";");
		j.execute("UPDATE car SET Available = 0 WHERE CarID = "+i.getCar()+";");
		j.execute("UPDATE Customer SET Points = "+i.getPoints()+" WHERE CustomerID = "+user+"");
		j.execute("COMMIT;");

	}
	
	@SuppressWarnings("unchecked")
	public void deleteItr(int TripID) {
		j.execute("START TRANSACTION;");
		j.execute("UPDATE room, itinerary SET Available = 1 WHERE RoomID = RRoom AND TripID = "+TripID+"");
		j.execute("UPDATE car, itinerary SET Available = 1 WHERE CarID = RCar AND TripID = "+TripID+";");
		j.execute("DELETE FROM payment WHERE PaymentID = (SELECT Payment FROM itinerary WHERE TripID = "+TripID+");");
		j.execute("UPDATE flight, itinerary SET Capacity = Capacity + 1 WHERE FlightNumber = RFlight AND TripID = "+TripID+";");
		j.execute("DELETE FROM itinerary WHERE TripID = "+TripID+";");
		j.execute("COMMIT;");
	}
	public void setSource() {
		j.setDataSource(new jdbcService().getData());
	}
}
